package compute

import (
	"context"
	"net/http"
	"strconv"

	"repository.basistech.ru/BASIS/decort-golang-sdk/internal/validators"
)

// DiskAttachRequest struct to attach disk to compute
type DiskAttachRequest struct {
	// ID of compute instance
	// Required: true
	ComputeID uint64 `url:"computeId" json:"computeId" validate:"required"`

	// ID of the disk to attach
	// Required: true
	DiskID uint64 `url:"diskId" json:"diskId" validate:"required"`

	// Desired PCI slot (hex string, e.g. "0x1A")
	// Required: false
	PCISlot string `url:"pci_slot,omitempty" json:"pci_slot,omitempty"`

	// Desired bus number (hex string, e.g. "0x03")
	// Required: false
	BusNumber string `url:"bus_number,omitempty" json:"bus_number,omitempty"`

	// Mount disk in read-only mode
	// Required: false
	ReadOnly bool `url:"read_only,omitempty" json:"read_only,omitempty"`
}

type wrapperDiskAttachRequest struct {
	DiskAttachRequest

	AsyncMode bool `url:"asyncMode"`
}

// DiskAttach attach disk to compute
func (c Compute) DiskAttach(ctx context.Context, req DiskAttachRequest) (bool, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return false, validators.ValidationErrors(validators.GetErrors(err))
	}

	reqWrapped := wrapperDiskAttachRequest{
		DiskAttachRequest: req,
		AsyncMode:         false,
	}

	url := "/cloudbroker/compute/diskAttach"

	res, err := c.client.DecortApiCall(ctx, http.MethodPost, url, reqWrapped)
	if err != nil {
		return false, err
	}

	result, err := strconv.ParseBool(string(res))
	if err != nil {
		return false, err
	}

	return result, nil
}

// DiskAttachAsync attach disk to compute with AsyncMode
func (c Compute) DiskAttachAsync(ctx context.Context, req DiskAttachRequest) (string, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return "", validators.ValidationErrors(validators.GetErrors(err))
	}

	reqWrapped := wrapperDiskAttachRequest{
		DiskAttachRequest: req,
		AsyncMode:         true,
	}

	url := "/cloudbroker/compute/diskAttach"

	res, err := c.client.DecortApiCall(ctx, http.MethodPost, url, reqWrapped)
	if err != nil {
		return "", err
	}

	return string(res), nil
}
